----------------------------------------------------------------
-----		 AddOn: Ketho CombatLog						--------		----> Insert some Warcraft 3 [Steam Tank] ASCII Art here ! <----
-----		Author: Ketho (EU-Boulderfist Alliance CHN) --------		   http://classic.battle.net/war3/human/units/siegeengine.shtml
-----	   Created: 2009.09.01 (1 September 2009)		--------
-----  Text Editor: Notepad++							--------	http://notepad-plus.sourceforge.net/
------ # Version -----------------------------------------------
-----  Ketho CombatLog				 v0.93 [2010.12.05] --------	http://wow.curse.com/downloads/wow-addons/details/ketho-combat.aspx
-----  Ace3 Development Framework	  r981 [2010.10.27] --------	http://wow.curse.com/downloads/wow-addons/details/ace3.aspx
------ # Features ----------------------------------------------
-----  01  Customizable CombatLog						--------
------ # Index -------------------------------------------------
-----  01  UPVALUES										--------	Line	26
-----  02  OPTIONS AND DEFAULT VARIABLES				--------	Line   168
-----  03  OnInitialize, OnEnable, OnDisable			--------	Line  1016
-----  04  CALLBACK HANDLERS							--------	Line  1072
-----  05  EVENT HANDLERS								--------	Line  1237
----------------------------------------------------------------
-- Note: This is my 1st AddOn
-- I don't have any previous programming experience/background in any language

KethoCombatLog = LibStub("AceAddon-3.0"):NewAddon("KethoCombatLog", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0") -- Instance of AceAddon Class http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
local KCL = KethoCombatLog -- abbreviated/upvalued; this points to the same "table object"
local L = LibStub("AceLocale-3.0"):GetLocale("KethoCombatLogLocale", true) -- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/

	-------------------------
	-----  01  UPVALUES -----
	-------------------------
-- Lua functions -- http://www.wowpedia.org/Lua_functions  /  http://www.lua.org/manual/5.1/
local _G = _G -- global table
local print, tonumber, select, date = _G.print, _G.tonumber, _G.select, _G.date -- os.date (mirror)
local format, gsub, strfind, strlen, strtrim = _G.format, _G.gsub, _G.strfind, _G.strlen, _G.strtrim -- string.format, string.gsub, string.find, string.len, string.trim (WoW Lua)
local band = _G.bit.band -- BitLib library
-- Spell School Strings (prevents global table lookups at every CLEU)
local STRING_SCHOOL_PHYSICAL = STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_HOLY = STRING_SCHOOL_HOLY
local STRING_SCHOOL_FIRE = STRING_SCHOOL_FIRE
local STRING_SCHOOL_NATURE = STRING_SCHOOL_NATURE
local STRING_SCHOOL_FROST = STRING_SCHOOL_FROST
local STRING_SCHOOL_SHADOW = STRING_SCHOOL_SHADOW
local STRING_SCHOOL_ARCANE = STRING_SCHOOL_ARCANE
local STRING_SCHOOL_HOLYSTRIKE = STRING_SCHOOL_HOLYSTRIKE
local STRING_SCHOOL_FLAMESTRIKE = STRING_SCHOOL_FLAMESTRIKE
local STRING_SCHOOL_HOLYFIRE = STRING_SCHOOL_HOLYFIRE
local STRING_SCHOOL_STORMSTRIKE = STRING_SCHOOL_STORMSTRIKE
local STRING_SCHOOL_HOLYSTORM = STRING_SCHOOL_HOLYSTORM
local STRING_SCHOOL_FIRESTORM = STRING_SCHOOL_FIRESTORM
local STRING_SCHOOL_FROSTSTRIKE = STRING_SCHOOL_FROSTSTRIKE
local STRING_SCHOOL_HOLYFROST = STRING_SCHOOL_HOLYFROST
local STRING_SCHOOL_FROSTFIRE = STRING_SCHOOL_FROSTFIRE
local STRING_SCHOOL_FROSTSTORM = STRING_SCHOOL_FROSTSTORM
local STRING_SCHOOL_SHADOWSTRIKE = STRING_SCHOOL_SHADOWSTRIKE
local STRING_SCHOOL_SHADOWLIGHT = STRING_SCHOOL_SHADOWLIGHT -- "Twilight"
local STRING_SCHOOL_SHADOWFLAME = STRING_SCHOOL_SHADOWFLAME
local STRING_SCHOOL_SHADOWSTORM = STRING_SCHOOL_SHADOWSTORM -- "Plague"
local STRING_SCHOOL_SHADOWFROST = STRING_SCHOOL_SHADOWFROST
local STRING_SCHOOL_SPELLSTRIKE = STRING_SCHOOL_SPELLSTRIKE
local STRING_SCHOOL_DIVINE = STRING_SCHOOL_DIVINE
local STRING_SCHOOL_SPELLFIRE = STRING_SCHOOL_SPELLFIRE	
local STRING_SCHOOL_SPELLSTORM = STRING_SCHOOL_SPELLSTORM
local STRING_SCHOOL_SPELLFROST = STRING_SCHOOL_SPELLFROST
local STRING_SCHOOL_SPELLSHADOW = STRING_SCHOOL_SPELLSHADOW
local STRING_SCHOOL_ELEMENTAL = STRING_SCHOOL_ELEMENTAL
local STRING_SCHOOL_CHROMATIC = STRING_SCHOOL_CHROMATIC
local STRING_SCHOOL_MAGIC = STRING_SCHOOL_MAGIC
local STRING_SCHOOL_CHAOS = STRING_SCHOOL_CHAOS
local STRING_SCHOOL_UNKNOWN = STRING_SCHOOL_UNKNOWN
-- UnitFlags Masks -- http://www.wowpedia.org/UnitFlag
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY -- 16(decimal) == 01000000(binary)
--local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL -- 32(decimal) == 00100000(binary)
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE -- 64(decimal) == 00010000(binary)
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1 -- 1048576(decimal)	== 100000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8
-- GlobalStrings.lua variables for in CLEU event handler -- http://wowprogramming.com/utils/xmlbrowser/test/FrameXML/GlobalStrings.lua
local TEXT_MODE_A_STRING_RESULT_OVERKILLING = TEXT_MODE_A_STRING_RESULT_OVERKILLING
local TEXT_MODE_A_STRING_RESULT_CRITICAL = TEXT_MODE_A_STRING_RESULT_CRITICAL
local TEXT_MODE_A_STRING_RESULT_CRUSHING = TEXT_MODE_A_STRING_RESULT_CRUSHING
local YOU, MELEE, PVP = YOU, MELEE, PVP
local QUICKBUTTON_NAME_SELF = QUICKBUTTON_NAME_SELF
local ACTION_UNIT_DIED = ACTION_UNIT_DIED
-- WoW API -- http://www.wowpedia.org/World_of_Warcraft_API
local GetTime = GetTime
local UnitName, UnitClass = UnitName, UnitClass
local UnitInParty, UnitInRaid = UnitInParty, UnitInRaid
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local IsInInstance = IsInInstance
local SCM = SendChatMessage
--# File-local Scope variables
local profile, char, CF -- KethoCombatLog.db.profile, ChatFrameN
local iconCropped = "64:64:4:60:4:60" -- http://www.wowpedia.org/UI_escape_sequences#Textures ; http://www.wowpedia.org/API_Texture_SetTexCoord
local playerName = UnitName("player")
local _, playerClass = UnitClass("player")
local englishPlayerFaction = UnitFactionGroup("player") -- for addon icon MountainKing/BladeMaster
local instanceType, announceType, lastDeath, playerColor
local timeSilence = 0
-- Upvalued Colors (Hex)
local hexTaunt, hexInterrupt, hexReflect, hexDispel, hexCrowdControl, hexCC_Break, hexDeath, hexResurrection
local hexPhysical, hexHoly, hexFire, hexNature, hexFrost, hexShadow, hexArcane
local hexDeathKnight, hexDruid, hexHunter, hexMage, hexPaladin, hexPriest, hexRogue, hexShaman, hexWarlock, hexWarrior
local hexFriendlyReaction, hexHostileReaction, hexUnknownReaction

local Taunt = {
-- Warrior
	355, -- Taunt
-- Paladin
	62124, -- Hand of Reckoning
	31790, -- Righteous Defense
-- Druid
	6795, -- Growl
-- Death Knight
	56222, -- Dark Command
	49560, -- Death Grip
	51399, -- Death Grip (melee range)
-- Hunter
	20736, -- Distracting Shot
-- Warlock	
	17735, -- Suffering [Voidwalker]
}

local Growl = {
	2649, -- Growl [Hunter]
	3716, -- Torment [Warlock - Voidwalker] ##
}

local CrowdControl = {
-- Mage
	118, -- Polymorph
	61305, -- Polymorph - Black Cat
	28272, -- Polymorph - Pig
	61721, -- Polymorph - Rabbit
	61780, -- Polymorph - Turkey
	28271, -- Polymorph - Turtle
-- Rogue
	6770, -- Sap
	2094, -- Blind
-- Hunter
	3355, -- Freezing Trap
	1513, -- Scare Beast
	19386, -- Wyvern Sting
-- Priest
	9484, -- Shackle Undead
-- Paladin
	10326, -- Turn Evil
	20066, -- Repentance
-- Warlock
	710, -- Banish
	6358, -- Seduction [Succubus]
-- Druid
	2637, -- Hibernate
	33786, -- Cyclone
-- Shaman
	51514, -- Hex
}

local cd = { -- Cooldown / Throttle
	instanceType = 0,
	Death = 0,
	Bloodlust = 0,
	RitualRefreshment = 0,
}

	-----------------------------------------------
	-----  02  OPTIONS AND DEFAULT VARIABLES  -----
	-----------------------------------------------
--- Blizzard GUI Options --- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local options = {
	type = "group",
	name = "",
	args = {
		optionsMain = {
			type = "group",
			name = "\124cffADFF2FKetho\124r |cffFFFFFFCombatLog|r |cffB6CA00v0.93|r                         |cffFFFFFF2010.12.05|r", -- Main Options Header
			handler = KCL,
			args = {
				toggleEnableAddOn = {
					type = "toggle",
					order = 1,
					width = "full",
					descStyle = "",
					name = "|cffFFFFFFEnable AddOn|r",
					get = function(info) return KCL.db.profile.enableAddOn end,
					set = function(info, value) KCL.db.profile.enableAddOn = value
						if value then KCL:Enable() -- Turn AddOn on
						else KCL:Disable() -- Turn AddOn off
						end
					end,
				},
				toggleTaunt = {
					type = "toggle",
					order = 2,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Nature_Reincarnation:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.Taunt.r,KCL.db.profile.color.Taunt.g,KCL.db.profile.color.Taunt.b).."Taunts|r" end,
					get = function(info) return KCL.db.profile.Taunt end,
					set = function(info, value) KCL.db.profile.Taunt = value end,
				},
				toggleCrowdControl = {
					type = "toggle",
					order = 3,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Nature_Polymorph:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.CrowdControl.r,KCL.db.profile.color.CrowdControl.g,KCL.db.profile.color.CrowdControl.b).."Crowd Control|r" end,
					get = function(info) return KCL.db.profile.CrowdControl end,
					set = function(info, value) KCL.db.profile.CrowdControl = value end,
				},
			--	force newline if BlizzardOptions/AceConfigDialogWindow has extra width; http://forums.wowace.com/showthread.php?p=312303
				newline01 = {type = "description", order = 4, name = ""},
				toggleInterrupt = {
					type = "toggle",
					order = 5,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Kick:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.Interrupt.r,KCL.db.profile.color.Interrupt.g,KCL.db.profile.color.Interrupt.b).."Interrupts|r" end,
					get = function(info) return KCL.db.profile.Interrupt end,
					set = function(info, value) KCL.db.profile.Interrupt = value end,
				},
				toggleCC_Break = {
					type = "toggle",
					order = 6,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Seal:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.CC_Break.r,KCL.db.profile.color.CC_Break.g,KCL.db.profile.color.CC_Break.b).."CC Breaker|r" end,
					get = function(info) return KCL.db.profile.CC_Break end,
					set = function(info, value) KCL.db.profile.CC_Break = value end,
				},
				newline02 = {type = "description", order = 7, name = ""},
				toggleDispel = {
					type = "toggle",
					order = 8,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Holy_DispelMagic:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.Dispel.r,KCL.db.profile.color.Dispel.g,KCL.db.profile.color.Dispel.b).."Dispels|r" end,
					get = function(info) return KCL.db.profile.Dispel end,
					set = function(info, value) KCL.db.profile.Dispel = value end,
				},
				toggleDeath = {
					type = "toggle",
					order = 9,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Rogue_FeignDeath:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.Death.r,KCL.db.profile.color.Death.g,KCL.db.profile.color.Death.b).."Deaths|r" end,
					get = function(info) return KCL.db.profile.Death end,
					set = function(info, value) KCL.db.profile.Death = value end,
				},
				newline03 = {type = "description", order = 10, name = ""},
				toggleReflect = {
					type = "toggle",
					order = 11,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.Reflect.r,KCL.db.profile.color.Reflect.g,KCL.db.profile.color.Reflect.b).."Reflects|r" end,
					get = function(info) return KCL.db.profile.Reflect end,
					set = function(info, value) KCL.db.profile.Reflect = value end,
				},
				toggleResurrection = {
					type = "toggle",
					order = 12,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Holy_Resurrection:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.color.Resurrection.r,KCL.db.profile.color.Resurrection.g,KCL.db.profile.color.Resurrection.b).."Resurrections|r" end,
					get = function(info) return KCL.db.profile.Resurrection end,
					set = function(info, value) KCL.db.profile.Resurrection = value end,
				},
				newline04 = {type = "description", order = 13, name = ""},
				header01 = {
					type = "header",
					order = 14,
					name = "",
				},
				toggleCombatPvE = {
					type = "toggle",
					order = 15,
					descStyle = "",
					name = "  |cffA8A8FFPvE|r", -- /dump ChatTypeInfo.PARTY {r = 0.666, g = 0.666, b = 1.000}
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.combatPvE end,
					set = function(info, value) KCL.db.profile.combatPvE = value end,
				},
				toggleTankTaunt = {
					type = "toggle",
					order = 16,
					descStyle = "",
					name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:28:28:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Spell_Nature_Reincarnation:24:24:0:0:"..iconCropped.."|t |cff6FAFE6"..TANK.."|r |cff"..KCL_Dec2Hex(KCL.db.profile.color.Taunt.r,KCL.db.profile.color.Taunt.g,KCL.db.profile.color.Taunt.b).."Taunts|r" end,
					disabled = function() if KCL.db.profile.Taunt == false or KCL.db.profile.enableAddOn == false then return true end; end,
					get = function(info) return KCL.db.profile.tankTaunt end,
					set = function(info, value) KCL.db.profile.tankTaunt = value end,
				},
				newline05 = {type = "description", order = 17, name = ""},
				toggleCombatPvP = {
					type = "toggle",
					order = 18,
					descStyle = "",
					name = "  |cffFF7F00"..PVP.."|r", -- /dump ChatTypeInfo.RAID {r = 1.000, g = 0.498, b = 0.000}
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.combatPvP end,
					set = function(info, value) KCL.db.profile.combatPvP = value end,
				},
				toggleTankBreaksCC = {
					type = "toggle",
					order = 19,
					descStyle = "",
					name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:28:28:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Ability_Seal:24:24:0:0:"..iconCropped.."|t |cff6FAFE6"..TANK.."|r |cff"..KCL_Dec2Hex(KCL.db.profile.color.CC_Break.r,KCL.db.profile.color.CC_Break.g,KCL.db.profile.color.CC_Break.b).."CC Breaks|r" end,
					disabled = function() if KCL.db.profile.CC_Break == false or KCL.db.profile.enableAddOn == false then return true end; end,
					get = function(info) return KCL.db.profile.tankBreaksCC end,
					set = function(info, value) KCL.db.profile.tankBreaksCC = value end,
				},
				newline06 = {type = "description", order = 20, name = ""},
				toggleCombatWorld = {
					type = "toggle",
					order = 21,
					descStyle = "",
					name = "  World",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.combatWorld end,
					set = function(info, value) KCL.db.profile.combatWorld = value end,
				},
				togglePetGrowl = {
					type = "toggle",
					order = 22,
					descStyle = "",
					name = function() return " |TInterface\\Icons\\INV_Weapon_Bow_07:24:24:-4:0:"..iconCropped.."|t|TInterface\\Icons\\Ability_Physical_Taunt:24:24:1:0:"..iconCropped.."|t  |cffABD473"..PET.."|r |cff"..KCL_Dec2Hex(KCL.db.profile.color.Taunt.r,KCL.db.profile.color.Taunt.g,KCL.db.profile.color.Taunt.b).."Growl|r" end,
					disabled = function() if KCL.db.profile.Taunt == false or KCL.db.profile.enableAddOn == false then return true end; end,
					get = function(info) return KCL.db.profile.petGrowl end,
					set = function(info, value) KCL.db.profile.petGrowl = value end,
				},
				newline07 = {type = "description", order = 23, name = ""},
				header02 = {
					type = "header",
					order = 24,
					name = "",
				},
				selectChatWindow = {
					type = "select",
					order = 25,
					descStyle = "",
					name = "   |cffFFFFFF"..CHAT.." Window|r",
					disabled = "OptionsDisabled",
					values = function() local ChatWindowList = {}
						ChatWindowList[1] = "|cffFF0000<"..ADDON_DISABLED..">|r"
						for i = 1, NUM_CHAT_WINDOWS do
							local a = GetChatWindowInfo(i)
							if a ~= "" then ChatWindowList[i+1] = "|cff2E9AFE"..i..".|r  "..select(1, GetChatWindowInfo(i)) end
						end
						return ChatWindowList end,
					get = function(info) return KCL.db.char.chatWindow end,
					set = function(info, value) KCL.db.char.chatWindow = value
						if value > 1 then
							CF = _G["ChatFrame"..value-1]
							CF:AddMessage("|cffADFF2FKetho CombatLog|r: Chat Frame |cff57A3FF"..(value-1)..".|r |cffADFF2F"..GetChatWindowInfo(value-1).."|r")
						end
					end,
				},
				selectChatChannel = {
					type = "select",
					order = 26,
					descStyle = "",
					name = "   |cffFFFFFF"..CHAT.." "..CHANNEL.."|r",
					values = function() local ChatChannelList = {}
						ChatChannelList[1] = "|cffFF0000<"..ADDON_DISABLED..">|r"
						ChatChannelList[2] = "|cff2E9AFE#|r   "..CHAT_MSG_SAY
						ChatChannelList[3] = "|cff2E9AFE#|r   |cffFF4040"..CHAT_MSG_YELL.."|r"
						ChatChannelList[4] = "|cff2E9AFE#|r   |cffA8A8FF"..CHAT_MSG_PARTY.."|r / |cffFF7F00"..CHAT_MSG_RAID.."|r"
						for i = 1, 10 do
							local a = select((i*2)-1, GetChannelList()) -- this is was kinda hard to code, seeing how GetChannelList() works..
							if a then ChatChannelList[a+4] = "|cff2E9AFE"..a..".|r  "..select(i*2,GetChannelList()) end
						end
						return ChatChannelList end,
					get = function(info) return KCL.db.char.chatChannel end,
					set = function(info, value) KCL.db.char.chatChannel = value end,
				},
			},
		},
		optionsAdvanced = {
			type = "group",
			name = "",
			handler = KCL,
			args = {
				groupColoring = {
					type = "group",
					order = 1,
					name = "|TInterface\\Icons\\INV_Misc_Gem_Variety_02:20:20:1:0:"..iconCropped.."|t  |cffFFFFFF"..COLORS.."|r",
					args = {
						colorTaunt = {
							type = "color",
							order = 1,
							name = "|TInterface\\Icons\\Spell_Nature_Reincarnation:20:20:1:0:"..iconCropped.."|t  Taunts",
							get = function(info) return KCL.db.profile.color.Taunt.r, KCL.db.profile.color.Taunt.g, KCL.db.profile.color.Taunt.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Taunt.r = r; KCL.db.profile.color.Taunt.g = g; KCL.db.profile.color.Taunt.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorInterrupt = {
							type = "color",
							order = 2,
							name = "|TInterface\\Icons\\Ability_Kick:20:20:1:0:"..iconCropped.."|t  "..INTERRUPTS,
							get = function(info) return KCL.db.profile.color.Interrupt.r, KCL.db.profile.color.Interrupt.g, KCL.db.profile.color.Interrupt.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Interrupt.r = r; KCL.db.profile.color.Interrupt.g = g; KCL.db.profile.color.Interrupt.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorDispel = {
							type = "color",
							order = 3,
							name = "|TInterface\\Icons\\Spell_Holy_DispelMagic:20:20:1:0:"..iconCropped.."|t  "..DISPELS,
							get = function(info) return KCL.db.profile.color.Dispel.r, KCL.db.profile.color.Dispel.g, KCL.db.profile.color.Dispel.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Dispel.r = r; KCL.db.profile.color.Dispel.g = g; KCL.db.profile.color.Dispel.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorReflect = {
							type = "color",
							order = 4,
							name = "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:20:20:1:0:"..iconCropped.."|t  Reflects",
							get = function(info) return KCL.db.profile.color.Reflect.r, KCL.db.profile.color.Reflect.g, KCL.db.profile.color.Reflect.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Reflect.r = r; KCL.db.profile.color.Reflect.g = g; KCL.db.profile.color.Reflect.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorCrowdControl = {
							type = "color",
							order = 5,
							name = "|TInterface\\Icons\\Spell_Nature_Polymorph:20:20:1:0:"..iconCropped.."|t  Crowd Control",
							get = function(info) return KCL.db.profile.color.CrowdControl.r, KCL.db.profile.color.CrowdControl.g, KCL.db.profile.color.CrowdControl.b end,
							set = function(info, r,g,b) KCL.db.profile.color.CrowdControl.r = r; KCL.db.profile.color.CrowdControl.g = g; KCL.db.profile.color.CrowdControl.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorCC_Break = {
							type = "color",
							order = 6,
							name = "|TInterface\\Icons\\Ability_Seal:20:20:1:0:"..iconCropped.."|t  CC Breaker",
							get = function(info) return KCL.db.profile.color.CC_Break.r, KCL.db.profile.color.CC_Break.g, KCL.db.profile.color.CC_Break.b end,
							set = function(info, r,g,b) KCL.db.profile.color.CC_Break.r = r; KCL.db.profile.color.CC_Break.g = g; KCL.db.profile.color.CC_Break.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorDeath = {
							type = "color",
							order = 7,
							name = "|TInterface\\Icons\\Ability_Rogue_FeignDeath:20:20:1:0:"..iconCropped.."|t  "..DEATHS,
							get = function(info) return KCL.db.profile.color.Death.r, KCL.db.profile.color.Death.g, KCL.db.profile.color.Death.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Death.r = r; KCL.db.profile.color.Death.g = g; KCL.db.profile.color.Death.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorResurrection = {
							type = "color",
							order = 8,
							name = "|TInterface\\Icons\\Spell_Holy_Resurrection:20:20:1:0:"..iconCropped.."|t  "..RESURRECT,
							get = function(info) return KCL.db.profile.color.Resurrection.r, KCL.db.profile.color.Resurrection.g, KCL.db.profile.color.Resurrection.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Resurrection.r = r; KCL.db.profile.color.Resurrection.g = g; KCL.db.profile.color.Resurrection.b = b; KCL_upvaluedOptionsHex() end,
						},
						description01 = {
							type = "description",
							order = 9,
							name = " ",
						},
						colorPhysicalSpellSchool = {
							type = "color",
							order = 10,
							name = "|TInterface\\Icons\\Spell_Nature_Strength:20:20:1:0:"..iconCropped.."|t  "..STRING_SCHOOL_PHYSICAL,
							get = function(info) return KCL.db.profile.color.PhysicalSpellSchool.r, KCL.db.profile.color.PhysicalSpellSchool.g, KCL.db.profile.color.PhysicalSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.PhysicalSpellSchool.r = r; KCL.db.profile.color.PhysicalSpellSchool.g = g; KCL.db.profile.color.PhysicalSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorHolySpellSchool = {
							type = "color",
							order = 11,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon2:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_HOLY,
							get = function(info) return KCL.db.profile.color.HolySpellSchool.r, KCL.db.profile.color.HolySpellSchool.g, KCL.db.profile.color.HolySpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.HolySpellSchool.r = r; KCL.db.profile.color.HolySpellSchool.g = g; KCL.db.profile.color.HolySpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorFireSpellSchool = {
							type = "color",
							order = 12,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon3:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FIRE,
							get = function(info) return KCL.db.profile.color.FireSpellSchool.r, KCL.db.profile.color.FireSpellSchool.g, KCL.db.profile.color.FireSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.FireSpellSchool.r = r; KCL.db.profile.color.FireSpellSchool.g = g; KCL.db.profile.color.FireSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorNatureSpellSchool = {
							type = "color",
							order = 13,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon4:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_NATURE,
							get = function(info) return KCL.db.profile.color.NatureSpellSchool.r, KCL.db.profile.color.NatureSpellSchool.g, KCL.db.profile.color.NatureSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.NatureSpellSchool.r = r; KCL.db.profile.color.NatureSpellSchool.g = g; KCL.db.profile.color.NatureSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorFrostSpellSchool = {
							type = "color",
							order = 14,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon5:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FROST,
							get = function(info) return KCL.db.profile.color.FrostSpellSchool.r, KCL.db.profile.color.FrostSpellSchool.g, KCL.db.profile.color.FrostSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.FrostSpellSchool.r = r; KCL.db.profile.color.FrostSpellSchool.g = g; KCL.db.profile.color.FrostSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorShadowSpellSchool = {
							type = "color",
							order = 15,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon6:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_SHADOW,
							get = function(info) return KCL.db.profile.color.ShadowSpellSchool.r, KCL.db.profile.color.ShadowSpellSchool.g, KCL.db.profile.color.ShadowSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.ShadowSpellSchool.r = r; KCL.db.profile.color.ShadowSpellSchool.g = g; KCL.db.profile.color.ShadowSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorArcaneSpellSchool = {
							type = "color",
							order = 16,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon7:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_ARCANE,
							get = function(info) return KCL.db.profile.color.ArcaneSpellSchool.r, KCL.db.profile.color.ArcaneSpellSchool.g, KCL.db.profile.color.ArcaneSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.color.ArcaneSpellSchool.r = r; KCL.db.profile.color.ArcaneSpellSchool.g = g; KCL.db.profile.color.ArcaneSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						description02 = {
							type = "description",
							order = 17,
							name = " ",
						},
						colorDeathKnight = {
							type = "color",
							order = 18,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:133:189|t  Death Knight",
							get = function(info) return KCL.db.profile.color.DeathKnight.r, KCL.db.profile.color.DeathKnight.g, KCL.db.profile.color.DeathKnight.b end,
							set = function(info, r,g,b) KCL.db.profile.color.DeathKnight.r = r; KCL.db.profile.color.DeathKnight.g = g; KCL.db.profile.color.DeathKnight.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorDruid = {
							type = "color",
							order = 19,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:194:250:4:60|t  Druid",
							get = function(info) return KCL.db.profile.color.Druid.r, KCL.db.profile.color.Druid.g, KCL.db.profile.color.Druid.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Druid.r = r; KCL.db.profile.color.Druid.g = g; KCL.db.profile.color.Druid.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorHunter = {
							type = "color",
							order = 20,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:68:124|t  Hunter",
							get = function(info) return KCL.db.profile.color.Hunter.r, KCL.db.profile.color.Hunter.g, KCL.db.profile.color.Hunter.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Hunter.r = r; KCL.db.profile.color.Hunter.g = g; KCL.db.profile.color.Hunter.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorMage = {
							type = "color",
							order = 21,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:4:60|t  Mage",
							get = function(info) return KCL.db.profile.color.Mage.r, KCL.db.profile.color.Mage.g, KCL.db.profile.color.Mage.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Mage.r = r; KCL.db.profile.color.Mage.g = g; KCL.db.profile.color.Mage.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorPaladin = {
							type = "color",
							order = 22,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:132:188|t  Paladin",
							get = function(info) return KCL.db.profile.color.Paladin.r, KCL.db.profile.color.Paladin.g, KCL.db.profile.color.Paladin.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Paladin.r = r; KCL.db.profile.color.Paladin.g = g; KCL.db.profile.color.Paladin.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorPriest = {
							type = "color",
							order = 23,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:130:186:68:124|t  Priest",
							get = function(info) return KCL.db.profile.color.Priest.r, KCL.db.profile.color.Priest.g, KCL.db.profile.color.Priest.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Priest.r = r; KCL.db.profile.color.Priest.g = g; KCL.db.profile.color.Priest.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorRogue = {
							type = "color",
							order = 24,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:131:187:4:60|t  Rogue",
							get = function(info) return KCL.db.profile.color.Rogue.r, KCL.db.profile.color.Rogue.g, KCL.db.profile.color.Rogue.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Rogue.r = r; KCL.db.profile.color.Rogue.g = g; KCL.db.profile.color.Rogue.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorShaman = {
							type = "color",
							order = 25,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:68:124|t  Shaman",
							get = function(info) return KCL.db.profile.color.Shaman.r, KCL.db.profile.color.Shaman.g, KCL.db.profile.color.Shaman.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Shaman.r = r; KCL.db.profile.color.Shaman.g = g; KCL.db.profile.color.Shaman.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorWarlock = {
							type = "color",
							order = 26,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:194:250:68:124|t  Warlock",
							get = function(info) return KCL.db.profile.color.Warlock.r, KCL.db.profile.color.Warlock.g, KCL.db.profile.color.Warlock.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Warlock.r = r; KCL.db.profile.color.Warlock.g = g; KCL.db.profile.color.Warlock.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorWarrior = {
							type = "color",
							order = 27,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:4:60|t  Warrior",
							get = function(info) return KCL.db.profile.color.Warrior.r, KCL.db.profile.color.Warrior.g, KCL.db.profile.color.Warrior.b end,
							set = function(info, r,g,b) KCL.db.profile.color.Warrior.r = r; KCL.db.profile.color.Warrior.g = g; KCL.db.profile.color.Warrior.b = b; KCL_upvaluedOptionsHex() end,
						},
						description03 = {
							type = "description",
							order = 28,
							name = " ",
						},
						colorFriendlyReaction = {
							type = "color",
							order = 29,
							name = "|TInterface\\Icons\\Spell_ChargePositive:20:20:1:0:"..iconCropped.."|t  "..COMBATLOG_FILTER_STRING_FRIENDLY_UNITS,
							get = function(info) return KCL.db.profile.color.FriendlyReaction.r, KCL.db.profile.color.FriendlyReaction.g, KCL.db.profile.color.FriendlyReaction.b end,
							set = function(info, r,g,b) KCL.db.profile.color.FriendlyReaction.r = r; KCL.db.profile.color.FriendlyReaction.g = g; KCL.db.profile.color.FriendlyReaction.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorHostileReaction = {
							type = "color",
							order = 30,
							name = "|TInterface\\Icons\\Spell_ChargeNegative:20:20:1:0:"..iconCropped.."|t  "..COMBATLOG_FILTER_STRING_HOSTILE_UNITS,
							get = function(info) return KCL.db.profile.color.HostileReaction.r, KCL.db.profile.color.HostileReaction.g, KCL.db.profile.color.HostileReaction.b end,
							set = function(info, r,g,b) KCL.db.profile.color.HostileReaction.r = r; KCL.db.profile.color.HostileReaction.g = g; KCL.db.profile.color.HostileReaction.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorUnknownReaction = {
							type = "color",
							order = 31,
							name = "|TInterface\\Icons\\INV_Misc_QuestionMark:20:20:1:0:"..iconCropped.."|t  "..COMBATLOG_FILTER_STRING_UNKNOWN_UNITS,
							get = function(info) return KCL.db.profile.color.UnknownReaction.r, KCL.db.profile.color.UnknownReaction.g, KCL.db.profile.color.UnknownReaction.b end,
							set = function(info, r,g,b) KCL.db.profile.color.UnknownReaction.r = r; KCL.db.profile.color.UnknownReaction.g = g; KCL.db.profile.color.UnknownReaction.b = b; KCL_upvaluedOptionsHex() end,
						},
						description04 = {
							type = "description",
							order = 32,
							name = "\n",
						},
						executeResetcolor = {
							type = "execute",
							order = 33,
							descStyle = "",
							name = "|TInterface\\Icons\\INV_Misc_Rune_01:20:20:1:0:"..iconCropped.."|t |cffFFFFFFReset Colors|r",
							confirm = true, confirmText = "Reset Colors?  |TInterface\\Icons\\INV_Misc_QuestionMark:22:22:1:0:"..iconCropped.."|t",
							func = function()
							--	for some weird reason the defaults also get saved/changed
							--	i coded something wrong i think, since it worked OK at some point; hardcoding it it in again then..
							--	KCL.db.profile.color = KCL.db.defaults.profile.color
								KCL.db.profile.color = {
									Taunt = {r = 1, g = 0, b = 0},
									Interrupt = {r = 0, g = 110/255, b = 1},
									Dispel = {r = 1, g = 1, b = 1},
									Reflect = {r = 1, g = 1, b = 1},
									CrowdControl = {r = 1, g = 1, b = 1},
									CC_Break = {r = 1, g = 1, b = 1},
									Death = {r = 1, g = 1, b = 1},
									Resurrection = {r = 175/255, g = 1, b = 47/255},
									PhysicalSpellSchool = {r = 1.00, g = 1.00, b = 0.00},
									HolySpellSchool = {r = 1.00, g = 0.90, b = 0.50},
									FireSpellSchool = {r = 1.00, g = 0.50, b = 0.00},
									NatureSpellSchool = {r = 0.30, g = 1.00, b = 0.30},
									FrostSpellSchool = {r = 0.50, g = 1.00, b = 1.00},
									ShadowSpellSchool = {r = 0.50, g = 0.50, b = 1.00},
									ArcaneSpellSchool = {r = 1.00, g = 0.50, b = 1.00},
									DeathKnight = {r = 0.77, g = 0.12, b = 0.23},
									Druid = {r = 1.00 , g = 0.49, b = 0.04},
									Hunter = {r = 0.67, g = 0.83, b = 0.45},
									Mage = {r = 0.41, g = 0.80, b = 0.94},
									Paladin = {r = 0.96, g = 0.55, b = 0.73},
									Priest = {r = 1.00, g = 1.00, b = 1.00},
									Rogue = {r = 1.00, g = 0.96, b = 0.41},
									Shaman = {r = 0.00, g = 0.44, b = 0.87},
									Warlock = {r = 0.58, g = 0.51, b = 0.79},
									Warrior = {r = 0.78, g = 0.61, b = 0.43},
									FriendlyReaction = {r = 0.34, g = 0.64, b = 1.00},
									HostileReaction = {r = 0.75, g = 0.05, b = 0.05},
									UnknownReaction = {r = 191/255, g = 191/255, b = 191/255},
								}
								KCL_upvaluedOptionsHex() -- update hex colors
							end,
						},
					},
				},
				groupAdvanced = {
					type = "group",
					order = 2,
					name = "|TInterface\\Icons\\Trade_Engineering:20:20:1:0:"..iconCropped.."|t  |cffFFFFFF"..ADVANCED_LABEL.."|r",
					args = {
						selectIconSize = {
							type = "select",
							order = 1,
							descStyle = "", 
							name = STAT_CATEGORY_SPELL.." "..EMBLEM_SYMBOL.." |cffFFFFFFSize|r", --  {1 "Disabled", 12-32 size}
							values = {"|cffFF0000<"..ADDON_DISABLED..">|r", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, " 12", nil, " 14", nil, " 16  |cffFBDB00(Default)|r", nil, " 18",  nil, " 20", nil, " 22", nil, " 24", nil, " 26", nil, " 28", nil, " 30", nil, " 32"},
							get = function(info) return KCL.db.profile.iconSize end,
							set = function(info, value) KCL.db.profile.iconSize = value end,
						},
						toggleCropIcon = {
							type = "toggle",
							order = 2,
							descStyle = "",
							name = "|TInterface\\Icons\\Trade_Engineering:26:26:1:0|t |TInterface\\Icons\\Trade_Engineering:24:24:1:0:64:64:4:60:4:60|t  |cffADFF2FCrop|r "..STAT_CATEGORY_SPELL.." "..EMBLEM_SYMBOL.."",
							disabled = function() if KCL.db.profile.DB_iconSize == false or KCL.db.profile.enableAddOn == false then return true end; end,
							get = function(info) return KCL.db.profile.iconCropped end,
							set = function(info, value) KCL.db.profile.iconCropped = value; if value then iconCropped = "64:64:4:60:4:60" else iconCropped = "" end; end,
						},
						header1 = {
							type = "header",
							order = 3,
							name = "",
						},
						toggleTimestamp = {
							type = "toggle",
							order = 4,
							desc = TIMESTAMP_COMBATLOG_TOOLTIP,
							name = TIMESTAMPS_LABEL,
							get = function(info) return KCL.db.profile.Timestamp end,
							set = function(info, value) KCL.db.profile.Timestamp = value end,
						},
						header2 = {
							type = "header",
							order = 5,
							name = "",
						},
						toggleBlizzardCombatLog = {
							type = "toggle",
							order = 6,
							desc = BINDING_NAME_TOGGLECOMBATLOG,
							name = "Blizzard CombatLog",
							get = function(info) return KCL.db.profile.BlizzardCombatLog end,
							set = function(info, value) KCL.db.profile.BlizzardCombatLog = value
								if value then COMBATLOG:RegisterEvent("COMBAT_LOG_EVENT"); print("Blizzard CombatLog: |cffB6CA00Enabled|r")
								else COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT") print("Blizzard CombatLog: |cffFF2424Disabled|r")
								end
							end,
						},
						toggleChatLogging = {
							type = "toggle",
							order = 7,
							descStyle = "",
							name = CHAT.." Logging",
							get = function(info) return KCL.db.profile.ChatLogging end,
							set = function(info, value) KCL.db.profile.ChatLogging = value
								if value then 
									if not LoggingChat() then LoggingChat(1); print("|cffFFFF00"..CHATLOGENABLED.."|r")
									else print("|cffFFFF00Already Enabled Chat Logging|r") end
								else
									if LoggingChat() then LoggingChat(0); print("|cffFFFF00"..CHATLOGDISABLED.."|r")
									else print("|cffFFFF00Already Disabled Chat Logging|r") end
								end
							end,
						},
						toggleCombatLogging = {
							type = "toggle",
							order = 8,
							descStyle = "",
							name = COMBAT.." Logging",
							get = function(info) return KCL.db.profile.CombatLogging end,
							set = function(info, value) KCL.db.profile.CombatLogging = value
								if value then
									if not LoggingCombat() then LoggingCombat(1); print("|cffFFFF00"..COMBATLOGENABLED.."|r")
									else print("|cffFFFF00Already Enabled Combat Logging|r") end
								else
									if LoggingCombat() then LoggingCombat(0); print("|cffFFFF00"..COMBATLOGDISABLED.."|r")
									else print("|cffFFFF00Already Disabled Combat Logging|r") end
								end
							end,
						},
					},
				},
				groupFun = {
					type = "group",
					order = 3,
					name = "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:20:20:1:0|t  |cffF6ADC6Fun|r",
					args = {
						toggleFeast = {
							type = "toggle",
							order = 1,
							desc = "|cffF6ADC6\"om nom nom nom\"|r", 
							name = "  Feasts",
							get = function(info) return KCL.db.profile.Feast end,
							set = function(info, value) KCL.db.profile.Feast = value end,
						},
						descriptionFeasts = {
							type = "description",
							order = 2,
							name = "     |TInterface\\Icons\\Spell_Misc_Food:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Food_Meat_Cooked_02:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Food_99:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Fish_52:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\Ability_Hunter_Pet_Boar:32:32:0:0:"..iconCropped.."|t",
						},
						header01 = {
							type = "header",
							order = 3,
							name = "",
						},
						toggleRepairBot = {
							type = "toggle",
							order = 4,
							desc = "|cffF6ADC6\"oh god not another wipe\"|r", 
							name = "  Repair Bots",
							get = function(info) return KCL.db.profile.RepairBot end,
							set = function(info, value) KCL.db.profile.RepairBot = value end,
						},
						descriptionRepairBot = {
							type = "description",
							order = 5,
							name = "     |TInterface\\Minimap\\Tracking\\Repair:36:36:-2:0:"..iconCropped.."|t    |TInterface\\Icons\\inv_pet_lilsmoky:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_EngGizmos_14:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\inv_misc_molle:32:32:0:0:"..iconCropped.."|t",
						},
						header02 = {
							type = "header",
							order = 6,
							name = "",
						},
						toggleFun = {
							type = "toggle",
							order = 7,
							desc = "|cffF6ADC6\"trolololol\"|r", 
							name = "  \"Fun\"",
							get = function(info) return KCL.db.profile.Fun end,
							set = function(info, value) KCL.db.profile.Fun = value end,
						},
						descriptionFun = {
							type = "description",
							order = 8,
							name = "     |TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:32:32:0:0|t    |TInterface\\Icons\\inv_misc_mohawkgrenade:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Toy_10:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Bag_28_Halloween:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Sandbox_Spectraltiger_01:32:32:0:0:"..iconCropped.."|t",
						},
						header03 = {
							type = "header",
							order = 9,
							name = "",
						},
					},
				},
				groupAbility = {
					type = "group",
					order = 4,
					name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:20:20:1:0:"..iconCropped.."|t  |cffFFFFFFAbility|r",
					args = {
						toggleSoulstoneResurrection = {
							type = "toggle",
							order = 1,
							desc = "Stores the friendly target's soul.  If the target dies while his soul is stored, he will be able to resurrect with |cff71D5FF30%|r health and |cff71D5FF30%|r mana.", 
							name = "|TInterface\\Icons\\Spell_Shadow_SoulGem:24:24:1:0:"..iconCropped.."|t  |cff9482C9Soulstone Resurrection|r",
							get = function(info) return KCL.db.profile.abilitySoulstone end,
							set = function(info, value) KCL.db.profile.abilitySoulstone = value end,
						},
						toggleFocusMagic = {
							type = "toggle",
							order = 2,
							desc = "Increases the target's chance to critically hit with spells by |cff71D5FF3%|r for |cff71D5FF30 min|r.  When the target critically hits your chance to critically hit with spells is increased by |cff71D5FF3%|r for |cff71D5FF10 sec|r.  Cannot be cast on self.  Limit 1 target.", 
							name = "|TInterface\\Icons\\Spell_Arcane_StudentOfMagic:24:24:1:0:"..iconCropped.."|t  |cff69CCF0Focus Magic|r",
							get = function(info) return KCL.db.profile.abilityFocusMagic end,
							set = function(info, value) KCL.db.profile.abilityFocusMagic = value end,
						},
						toggleVigilance = {
							type = "toggle",
							order = 3,
							desc = "Focus your protective gaze on a group or raid target.  Each time they are hit by an attack your |cff71D5FFTaunt|r cooldown is refreshed and you gain |cff71D5FFVengeance|r as if |cff71D5FF20%|r of the damage was done to you.  Lasts |cff71D5FF30 min|r.  This effect can only be on one target at a time.", 
							name = "|TInterface\\Icons\\Ability_Warrior_Vigilance:24:24:1:0:"..iconCropped.."|t  |cffC79C6EVigilance|r",
							get = function(info) return KCL.db.profile.abilityVigilance end,
							set = function(info, value) KCL.db.profile.abilityVigilance = value end,
						},
						toggleMisdirection = {
							type = "toggle",
							order = 4,
							desc = "The current party or raid member targeted will receive the threat caused by your next damaging attack and all actions taken for |cff71D5FF4 sec|r afterwards.  Transferred threat is not permanent, and will fade after |cff71D5FF30 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Hunter_Misdirection:24:24:1:0:"..iconCropped.."|t  |cffABD473Misdirection|r",
							get = function(info) return KCL.db.profile.abilityMisdirection end,
							set = function(info, value) KCL.db.profile.abilityMisdirection = value end,
						},
						toggleTricksTrade = {
							type = "toggle",
							order = 5,
							desc = "The threat caused by your next damaging attack and all actions taken for |cff71D5FF6 sec|r afterwards will be transferred to the target party or raid member, and all damage caused by the target is increased by |cff71D5FF15%|r during this time.  Transferred threat is not permanent, and will fade after |cff71D5FF30 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:24:24:1:0:"..iconCropped.."|t  |cffFFF569Tricks of the Trade|r",
							get = function(info) return KCL.db.profile.abilityTricksTrade end,
							set = function(info, value) KCL.db.profile.abilityTricksTrade = value end,
						},
						toggleInnervate = {
							type = "toggle",
							order = 6,
							desc = "Causes the target to regenerate mana equal to |cff71D5FF20%|r of the casting |cffFF7D0ADruid's|r maximum mana pool over |cff71D5FF10 sec|r.", 
							name = "|TInterface\\Icons\\Spell_Nature_Lightning:24:24:1:0:"..iconCropped.."|t  |cffFF7D0AInnervate|r",
							get = function(info) return KCL.db.profile.abilityInnervate end,
							set = function(info, value) KCL.db.profile.abilityInnervate = value end,
						},
						toggleHeroismBloodlust = {
							type = "toggle",
							order = 7,
							desc = "Increases melee, ranged, and spell casting speed by |cff71D5FF30%|r for all party and raid members.  Lasts |cff71D5FF40 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Shaman_Heroism:24:24:1:0:"..iconCropped.."|t |TInterface\\Icons\\Spell_Nature_BloodLust:24:24:1:0:"..iconCropped.."|t  |cff0070DEHeroism|r / |cff0070DEBloodlust|r",
							get = function(info) return KCL.db.profile.abilityBloodlust end,
							set = function(info, value) KCL.db.profile.abilityBloodlust = value end,
						},
						toggleRitualRefreshment = {
							type = "toggle",
							order = 8,
							desc = "Begins a ritual that creates a refreshment table.  Raid members can click the table to acquire Conjured mana food.  The tables lasts for |cff71D5FF3 min|r or |cff71D5FF50 charges|r.  Requires the caster and 2 additional party members to complete the ritual.  In order to participate, all players must right-click the refreshment portal and not move until the ritual is complete.", 
							name = "|TInterface\\Icons\\Spell_Arcane_MassDispel:24:24:1:0:"..iconCropped.."|t  |cff69CCF0Ritual of Refreshment|r",
							get = function(info) return KCL.db.profile.abilityRitualRefreshment end,
							set = function(info, value) KCL.db.profile.abilityRitualRefreshment = value end,
						},
						toggleFearWard = {
							type = "toggle",
							order = 9,
							desc = "Wards the friendly target against |cff71D5FFFear|r.  The next Fear effect used against the target will fail, using up the ward.  Lasts |cff71D5FF3 min|r.", 
							name = "|TInterface\\Icons\\Spell_Holy_Excorcism:24:24:1:0:"..iconCropped.."|t  Fear Ward",
							get = function(info) return KCL.db.profile.abilityFearWard end,
							set = function(info, value) KCL.db.profile.abilityFearWard = value end,
						},
						toggleMindVision = {
							type = "toggle",
							order = 10,
							desc = "Allows the caster to see through the target's eyes for |cff71D5FF1 min|r.  Will not work if the target is in another instance or on another continent.", 
							name = "|TInterface\\Icons\\Spell_Holy_MindVision:24:24:1:0:"..iconCropped.."|t  Mind Vision",
							get = function(info) return KCL.db.profile.abilityMindVision end,
							set = function(info, value) KCL.db.profile.abilityMindVision = value end,
						},
					},
				},
				groupAbout = {
					type = "group",
					order = 5,
					name = "|TInterface\\Icons\\INV_Misc_QuestionMark:20:20:1:0:"..iconCropped.."|t  |cffFFFFFFAbout|r",
					args = {
						header01 = {
							type = "header",
							order = 1,
							name = "|cffADFF2FKetho|r |cffFFFFFFCombatLog|r",
						},
						descriptionAuthor = {
							type = "description",
							order = 2,
							fontSize = "medium",
							name = "Author: |cffADFF2FKetho|r @ |cffB6CA00EU-Boulderfist|r",
						},
						descriptionHost = {
							type = "description",
							order = 3,
							fontSize = "medium",
							name = "Download: |cffB6CA00Curse|r & |cff87CEFAWoWInterface\n",
						},
						header02 = {
							type = "header",
							order = 4,
							name = "Changelog |cffB6CA00v0.91, v0.92, v0.93|r",
						},
						description02 = {
							type = "description",
							order = 5,
							name = "|cffADFF2Fv0.91)|r |cffB6CA00Added:|r Say, Yell channel options\n|cffB6CA00Fixed:|r Critical/Crushing melee swing death message\n|cffADFF2Fv0.92)|r |cffB6CA00Fixed:|r AddOn, Repair Bot, Fun, Crowd Control\n|cffB6CA00Added options:|r Toggle Blizzard CombatLog, Chat/Combat Logging\n|cffADFF2Fv0.93)|r Hotfixed TOC",
						},
						header03 = {
							type = "header",
							order = 6,
							name = "To Do",
						},
						description03 = {
							type = "description",
							order = 7,
							name = "- Locales\n",
						},
						header04 = {
							type = "header",
							order = 8,
							name = "Known Bugs",
						},
						description04 = {
							type = "description",
							order = 9,
							name = "1) Rarely shows |cff71D5FF\"false positive Deaths\"|r\n2) |cff71D5FFDuel Losses|r show as deaths\n3) Attempts to announce say/yell if dead\n\n\n\n\n",
						},
						description05 = {
							type = "description",
							order = 10,
							name = function() local a; if englishPlayerFaction == "Alliance" then a = "War3_MountainKing" elseif englishPlayerFaction == "Horde" then a = "War3_Blademaster" end
								return "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\"..a..":64:64:2:0|t" end,
						},
					},
				},
			},
		},
		optionsProfiles = { -- how to not show Profiles in a "group"? it always shows in a tree/select/tab group .. if you get what i mean.. lol im randomly talking to ppl in my comments ><
			type = "group",
			name = "",
			args = {
				profiles = {
					type = "group",
					name = "",
					inline = true,
					args = {
						profiles = {
							type = "group",
							name = "",
						},
					},
				},
			},
		},
	},
}

--- Blizzard GUI Defaults ---
local defaults = {
	profile = {
		enableAddOn = true,
		Taunt = true,
		Death = true,
		combatPvE = true,
		color = {
			Taunt = {r = 1, g = 0, b = 0}, -- #FF0000
			Interrupt = {r = 0, g = 110/255, b = 1}, -- #006EFF
			Dispel = {r = 1, g = 1, b = 1},
			Reflect = {r = 1, g = 1, b = 1},
			Death = {r = 1, g = 1, b = 1},
			Resurrection = {r = 175/255, g = 1, b = 47/255}, -- #ADFF2F (GreenYellow)
			CrowdControl = {r = 1, g = 1, b = 1},
			CC_Break = {r = 1, g = 1, b = 1},
	--	http://www.wowpedia.org/API_COMBAT_LOG_EVENT#Spell_School
			PhysicalSpellSchool = {r = 1.00, g = 1.00, b = 0.00}, -- #FFFF00
			HolySpellSchool = {r = 1.00, g = 0.90, b = 0.50}, -- #FFE680
			FireSpellSchool = {r = 1.00, g = 0.50, b = 0.00}, -- #FF8000
			NatureSpellSchool = {r = 0.30, g = 1.00, b = 0.30}, -- #4DFF4D
			FrostSpellSchool = {r = 0.50, g = 1.00, b = 1.00}, -- #80FFFF
			ShadowSpellSchool = {r = 0.50, g = 0.50, b = 1.00}, -- #8080FF
			ArcaneSpellSchool = {r = 1.00, g = 0.50, b = 1.00}, -- #FF80FF
	--	http://www.wowpedia.org/Class_colors
			DeathKnight = {r = 0.77, g = 0.12, b = 0.23}, -- #C41F3B
			Druid = {r = 1.00 , g = 0.49, b = 0.04}, -- #FF7D0A
			Hunter = {r = 0.67, g = 0.83, b = 0.45}, -- #ABD473
			Mage = {r = 0.41, g = 0.80, b = 0.94}, -- #69CCF0
			Paladin = {r = 0.96, g = 0.55, b = 0.73}, -- #F58CBA
			Priest = {r = 1.00, g = 1.00, b = 1.00}, -- #FFFFFF
			Rogue = {r = 1.00, g = 0.96, b = 0.41}, -- #FFF569
			Shaman = {r = 0.00, g = 0.44, b = 0.87}, -- #0070DE
			Warlock = {r = 0.58, g = 0.51, b = 0.79}, -- #9482C9
			Warrior = {r = 0.78, g = 0.61, b = 0.43}, -- #C79C6E
			FriendlyReaction = {r = 0.34, g = 0.64, b = 1.00}, -- #57A3FF ..\Interface\AddOns\Blizzard_CombatLog\Blizzard_CombatLog.lua >> COMBATLOG_DEFAULT_COLORS.unitColoring["COMBATLOG_FILTER_FRIENDLY_UNITS"]
			HostileReaction = {r = 0.75, g = 0.05, b = 0.05}, -- #BF0D0D
			UnknownReaction = {r = 191/255, g = 191/255, b = 191/255}, -- #BFBFBF
		},
		iconSize = 16,
		iconCropped = true,
		BlizzardCombatLog = true,
	},
	char = {
		chatWindow = 2, -- ChatFrame1
		chatChannel = 1, -- Disabled
	},
}

	--------------------------------------------------
	-----  03 OnInitialize, OnEnable, OnDisable  -----
	--------------------------------------------------
function KCL:OnInitialize() -- Called when the addon is loaded
--	Creates a new database object that can be used to handle database settings and profiles -- http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("KethoCombatLogDB", defaults, true) -- KethoCombatLog.db
	self.db.RegisterCallback(self, "OnProfileReset", function() KCL_upvaluedOptionsHex() end) -- update hex colors with profile reset; http://www.wowace.com/addons/ace3/pages/ace-db-3-0-tutorial/
	profile, char, ability = self.db.profile, self.db.char, self.db.profile.ability -- 1 table lookup instead of 3

--	Register an options table with the config registry -- http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	local ACR = LibStub("AceConfigRegistry-3.0")
	ACR:RegisterOptionsTable("KethoCombatLog_Main", options.args.optionsMain)
	ACR:RegisterOptionsTable("KethoCombatLog_Advanced", options.args.optionsAdvanced)
	ACR:RegisterOptionsTable("KethoCombatLog_Profiles", options.args.optionsProfiles)
	
--	Add an option table into the Blizzard Interface Options panel -- http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/	
	local ACD = LibStub("AceConfigDialog-3.0"); local optionsMainName = "Ketho |cffFFFFFFCombatLog|r|TInterface\\Icons\\INV_Sword_01:20:20:8:0:"..iconCropped.."|t"
	self.optionsFrame = ACD:AddToBlizOptions("KethoCombatLog_Main", optionsMainName) -- "self.optionsFrame" used for "InterfaceOptionsFrame_OpenToCategory"
	ACD:AddToBlizOptions("KethoCombatLog_Advanced", "|TInterface\\Icons\\Trade_Engineering:24:24:1:0:"..iconCropped.."|t  "..ADVANCED_LABEL, optionsMainName)
	ACD:AddToBlizOptions("KethoCombatLog_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:24:24:1:0:"..iconCropped.."|t  Profiles", optionsMainName)

--	Get/Create a option table that you can use in your addon to control the profiles of AceDB-3.0 -- http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	options.args.optionsProfiles.args.profiles.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db) -- STILL dont understand how it works with the "groups" and stuff

--	Register chat commands -- http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("ket", "slashCommand")
	self:RegisterChatCommand("kcl", "slashCommand")
	self:RegisterChatCommand("ketho", "slashCommand")
	self:RegisterChatCommand("kethocombat", "slashCommand")
	self:RegisterChatCommand("kethocombatlog", "slashCommand")
	
--	Initialize upvalued stuff from the AceDB / AddOn API
	if char.chatWindow > 1 then CF = _G["ChatFrame"..char.chatWindow-1] end
	if profile.ChatLogging then LoggingChat(1) end -- dont disable logging if the option is false, so it wont interfere with other addons setting it
	if profile.CombatLogging then LoggingCombat(1) end
	if profile.iconCropped then iconCropped = "64:64:4:60:4:60" else iconCropped = "" end
	KCL_upvaluedOptionsHex() -- update upvalued options (hex)
	playerColor = KCL_UnitLinkClass("player", nil, playerClass) -- this must be called after KCL_upvaluedOptions(), since hexColors arent initialized before it

	if profile.Debug then self:Print("Initialized (|cff71D5FFOnInitialize|r)") end
	if profile.enableAddOn == false then self:Disable() -- Turn AddOn off again
		if profile.Debug then self:Print("|cffFF2424Disabled|r (|cff71D5FFOnInitialize|r)") end
	end
end

function KCL:OnEnable() -- Called when the addon is enabled	
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") -- Subscribe to Events
	self:RegisterEvent("ADDON_LOADED")
	if profile.Debug then self:Print("|cffB6CA00Enabled|r (|cff71D5FFOnEnable|r)") end
end

function KCL:OnDisable() -- Called when the addon is disabled
	self:UnregisterAllEvents() -- Unsubscribe from all Events
	if profile.Debug then self:Print("|cffFF2424Disabled|r (|cff71D5FFOnDisable|r)") end
end

	-----------------------------------
	-----  04  CALLBACK HANDLERS  -----
	-----------------------------------
function KCL:OptionsDisabled() -- Disables(gray out) options when AddOn disabled
	if self.db.profile.enableAddOn == false then return true end
end

function KCL_upvaluedOptionsHex()
	local color = KCL.db.profile.color
--	hexTaunt = KCL_Dec2Hex(unpack(color.Taunt)) -- how to properly implement unpack() ?
	hexTaunt = KCL_Dec2Hex(color.Taunt.r, color.Taunt.g, color.Taunt.b)
	hexInterrupt = KCL_Dec2Hex(color.Interrupt.r, color.Interrupt.g, color.Interrupt.b)
	hexReflect = KCL_Dec2Hex(color.Reflect.r, color.Reflect.g, color.Reflect.b)
	hexDispel = KCL_Dec2Hex(color.Dispel.r, color.Dispel.g, color.Dispel.b)
	hexCrowdControl = KCL_Dec2Hex(color.CrowdControl.r, color.CrowdControl.g, color.CrowdControl.b)
	hexCC_Break = KCL_Dec2Hex(color.CC_Break.r, color.CC_Break.g, color.CC_Break.b)
	hexDeath = KCL_Dec2Hex(color.Death.r, color.Death.g, color.Death.b)
	hexResurrection = KCL_Dec2Hex(color.Resurrection.r, color.Resurrection.g, color.Resurrection.b)
	hexPhysical = KCL_Dec2Hex(color.PhysicalSpellSchool.r, color.PhysicalSpellSchool.g, color.PhysicalSpellSchool.b)
	hexHoly = KCL_Dec2Hex(color.HolySpellSchool.r, color.HolySpellSchool.g, color.HolySpellSchool.b)
	hexFire = KCL_Dec2Hex(color.FireSpellSchool.r, color.FireSpellSchool.g, color.FireSpellSchool.b)
	hexNature = KCL_Dec2Hex(color.NatureSpellSchool.r, color.NatureSpellSchool.g, color.NatureSpellSchool.b)
	hexFrost = KCL_Dec2Hex(color.FrostSpellSchool.r, color.FrostSpellSchool.g, color.FrostSpellSchool.b)
	hexShadow = KCL_Dec2Hex(color.ShadowSpellSchool.r, color.ShadowSpellSchool.g, color.ShadowSpellSchool.b)
	hexArcane = KCL_Dec2Hex(color.ArcaneSpellSchool.r, color.ArcaneSpellSchool.g, color.ArcaneSpellSchool.b)
	hexDeathKnight = KCL_Dec2Hex(color.DeathKnight.r, color.DeathKnight.g, color.DeathKnight.b)
	hexDruid = KCL_Dec2Hex(color.Druid.r, color.Druid.g, color.Druid.b)
	hexHunter = KCL_Dec2Hex(color.Hunter.r, color.Hunter.g, color.Hunter.b)
	hexMage = KCL_Dec2Hex(color.Mage.r, color.Mage.g, color.Mage.b)
	hexPaladin = KCL_Dec2Hex(color.Paladin.r, color.Paladin.g, color.Paladin.b)
	hexPriest = KCL_Dec2Hex(color.Priest.r, color.Priest.g, color.Priest.b)
	hexRogue = KCL_Dec2Hex(color.Rogue.r, color.Rogue.g, color.Rogue.b)
	hexShaman = KCL_Dec2Hex(color.Shaman.r, color.Shaman.g, color.Shaman.b)
	hexWarlock = KCL_Dec2Hex(color.Warlock.r, color.Warlock.g, color.Warlock.b)
	hexWarrior = KCL_Dec2Hex(color.Warrior.r, color.Warrior.g, color.Warrior.b)
	hexFriendlyReaction = KCL_Dec2Hex(color.FriendlyReaction.r, color.FriendlyReaction.g, color.FriendlyReaction.b)
	hexHostileReaction = KCL_Dec2Hex(color.HostileReaction.r, color.HostileReaction.g, color.HostileReaction.b)
	hexUnknownReaction = KCL_Dec2Hex(color.UnknownReaction.r, color.UnknownReaction.g, color.UnknownReaction.b)
end

function KCL:slashCommand(input) -- Process the slash command ('input' contains whatever follows the slash command)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)

	elseif input == "on" then
		if profile.enableAddOn == false then self:Enable(); profile.enableAddOn = true; self:Print("|cffB6CA00Enabled|r") else self:Print("Already |cffB6CA00Enabled|r") end LibStub("AceConfigRegistry-3.0"):NotifyChange("KCL_optionsMain")
	elseif input == "off" then
		if profile.enableAddOn then self:Disable(); profile.enableAddOn = false; self:Print("|cffFF2424Disabled|r") else self:Print("Already |cffFF2424Disabled|r") end LibStub("AceConfigRegistry-3.0"):NotifyChange("KCL_optionsMain")

	elseif input == "silence" then -- AceTimer here is only for feedback purpose
		if timeSilence == 0 then self:Print("Silenced: 1 Minute")
		else self:Print("Refreshed Silence: 1 Minute"); self:CancelTimer(self.silenceTimer, true) end
		timeSilence = GetTime() + 60; self.silenceTimer = self:ScheduleTimer(function() timeSilence = 0; self:Print("Unsilenced") end, 60)
	elseif input == "unsilence" then
		if timeSilence > 0 then self:Print("Unsilenced")
		else self:Print("Already Unsilenced") end
		timeSilence = 0; self:CancelTimer(self.silenceTimer, true) -- check if it silently fails if no AceTimer handle

	elseif input == "debug" then if profile.Debug then profile.Debug = false; self:Print("Debug: |cffFF2424Off|r") else profile.Debug = true; self:Print("Debug: |cffB6CA00On|r") end
	else local a, b, c = "|cff2E9AFE", "|cffB6CA00", "|cffFF2424"; print(a.."/ket|r: Opens Options\n"..a.."/ket|r "..b.."on|r: Turns AddOn on\n"..a.."/ket|r "..c.."off|r: Turns AddOn off\n"..a.."/ket|r "..c.."silence|r: Stops announce for |cff71D5FF60 sec.|r\n"..a.."/ket|r "..b.."un|r"..c.."silence|r: Resumes announce\n"..a.."/ket|r |cff71D5FFdebug|r: Toggles debug mode")
	end
end

function KCL_Dec2Hex(R, G, B) -- Convert: Decimal (0-255) -> Hexadecimal -- http://www.wowpedia.org/RGBToHex
	return string.format("%02X%02X%02X", R*255, G*255, B*255)
end

function KCL_checkTable(spellID, Table)
	for _, v in pairs(Table) do
		if v == spellID then
			return true
		end
	end
end

-- Class Color, Unit Link
function KCL_UnitLinkClass(info, unitID, unitClass, unitGUID, sourceName, destName) -- http://www.wowpedia.org/Class_colors
	local classColor, name
	if	   unitClass == "DEATHKNIGHT" then classColor = hexDeathKnight
	elseif unitClass == "DRUID"		  then classColor = hexDruid
	elseif unitClass == "HUNTER"	  then classColor = hexHunter
	elseif unitClass == "MAGE"		  then classColor = hexMage
	elseif unitClass == "PALADIN"	  then classColor = hexPaladin
	elseif unitClass == "PRIEST"	  then classColor = hexPriest
	elseif unitClass == "ROGUE"		  then classColor = hexRogue
	elseif unitClass == "SHAMAN"	  then classColor = hexShaman
	elseif unitClass == "WARLOCK"	  then classColor = hexWarlock
	elseif unitClass == "WARRIOR"	  then classColor = hexWarrior
	end
	if unitID == "group" and destName then name = UnitName(destName)
	elseif unitID == "group" and not destName then name = UnitName(sourceName)
	elseif unitID == "target" then name = UnitName("target")
	end
	if info == "source" then
		return name, "|cff"..classColor.."|Hunit:"..unitGUID..":"..name.."|h["..name.."]|h|r"
	elseif info == "dest" then local a
		if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = name end
		return name, "|cff"..classColor.."|Hunit:"..unitGUID..":"..name.."|h["..a.."]|h|r"
	elseif info == "player" then
		return classColor
	end
end

-- Spell School (Colored), Extra Spell School (Colored)
function KCL_spellSchool(value)
	local a, b
	if	   value == 0x1  then a = STRING_SCHOOL_PHYSICAL; b = hexPhysical
	elseif value == 0x2  then a = STRING_SCHOOL_HOLY;	  b = hexHoly
	elseif value == 0x4  then a = STRING_SCHOOL_FIRE;	  b = hexFire
	elseif value == 0x8  then a = STRING_SCHOOL_NATURE;	  b = hexNature
	elseif value == 0x10 then a = STRING_SCHOOL_FROST;	  b = hexFrost
	elseif value == 0x20 then a = STRING_SCHOOL_SHADOW;	  b = hexShadow
	elseif value == 0x40 then a = STRING_SCHOOL_ARCANE;	  b = hexArcane
--	Double schools
	elseif value == 0x3  then a = STRING_SCHOOL_HOLYSTRIKE
	elseif value == 0x5  then a = STRING_SCHOOL_FLAMESTRIKE
	elseif value == 0x6  then a = STRING_SCHOOL_HOLYFIRE
	elseif value == 0x9  then a = STRING_SCHOOL_STORMSTRIKE
	elseif value == 0xA  then a = STRING_SCHOOL_HOLYSTORM
	elseif value == 0xC  then a = STRING_SCHOOL_FIRESTORM
	elseif value == 0x11 then a = STRING_SCHOOL_FROSTSTRIKE
	elseif value == 0x12 then a = STRING_SCHOOL_HOLYFROST
	elseif value == 0x14 then a = STRING_SCHOOL_FROSTFIRE
	elseif value == 0x18 then a = STRING_SCHOOL_FROSTSTORM
	elseif value == 0x21 then a = STRING_SCHOOL_SHADOWSTRIKE
	elseif value == 0x22 then a = STRING_SCHOOL_SHADOWLIGHT
	elseif value == 0x24 then a = STRING_SCHOOL_SHADOWFLAME
	elseif value == 0x28 then a = STRING_SCHOOL_SHADOWSTORM
	elseif value == 0x30 then a = STRING_SCHOOL_SHADOWFROST
	elseif value == 0x41 then a = STRING_SCHOOL_SPELLSTRIKE
	elseif value == 0x42 then a = STRING_SCHOOL_DIVINE
	elseif value == 0x44 then a = STRING_SCHOOL_SPELLFIRE			
	elseif value == 0x48 then a = STRING_SCHOOL_SPELLSTORM
	elseif value == 0x50 then a = STRING_SCHOOL_SPELLFROST
	elseif value == 0x60 then a = STRING_SCHOOL_SPELLSHADOW
--	Three or more schools
	elseif value == 0x1C then a = STRING_SCHOOL_ELEMENTAL
	elseif value == 0x7C then a = STRING_SCHOOL_CHROMATIC
	elseif value == 0x7E then a = STRING_SCHOOL_MAGIC
	elseif value == 0x7F then a = STRING_SCHOOL_CHAOS
	else a = STRING_SCHOOL_UNKNOWN.." ("..value..")"
	end
	if not b then b = "71D5FF" end
	return a, b, "|cff"..b..a.."|r" -- school(Name)(Color), extraSchool(Name)(Color)
end

-- Unit Reaction (Colored), Raid Target Icon
function KCL_UnitFlags(info, Flags)
	if info == "reaction" then
		if band(Flags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 then return hexFriendlyReaction -- Friendly Reaction Color
		elseif band(Flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then return hexHostileReaction -- Hostile Reaction Color
		else return hexUnknownReaction -- Unknown Reaction Color
		end
	elseif info == "raidtarget" then
		local a, b = "", ""
		for i = 1, 8 do
			if band(Flags, _G["COMBATLOG_OBJECT_RAIDTARGET"..i]) > 0 then -- .. does this defeat the purpose of upvalues?
				a = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..i..":"..profile.iconSize.."|t" -- Raid Target Icon
				b = "{rt"..i.."}"
			end
		end
		return a, b
	end
end

	--------------------------------
	-----  05  EVENT HANDLERS  -----
	--------------------------------
function KCL:ADDON_LOADED(event, addon) -- Blizzard CombatLog is Load-on-Demand and dont wanna load it before Ketho CombatLog, just to "disable" it again
	if addon == "Blizzard_CombatLog" and profile.BlizzardCombatLog == false then
		COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT") -- disable Blizzard CombatLog
	end
end

function KCL:COMBAT_LOG_EVENT_UNFILTERED(CLEU, ...)
	local _, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool, SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, _, SuffixParam6, SuffixParam7, _, SuffixParam9 = ...

	local Time = GetTime()
	if profile.Debug then print(...) end
--	Refresh instanceType & announceType every 10 sec
	if Time > cd.instanceType then
		cd.instanceType = Time + 10; _, instanceType = IsInInstance()
		if instanceType == "party" or instanceType == "arena" then announceType = "PARTY"
		elseif instanceType == "raid" then announceType = "RAID"
		end
	end
--	InstanceType check (so the "workload" is optionally)
	if ((instanceType == "party" or instanceType == "raid") and profile.combatPvE) or
	((instanceType == "pvp" or instanceType == "arena") and profile.combatPvP) or
	(instanceType == "none" and profile.combatWorld) then

	---- Initialization ----
	--	Unit Type, Unit Reaction Coloring -- http://www.wowpedia.org/API_UnitGUID
		local sourceType = tonumber(strsub(sourceGUID, 5, 5)) -- 5th digit, string converted to number (decimal)
		local destType = tonumber(strsub(destGUID, 5, 5))
		local sourceReaction = KCL_UnitFlags("reaction", sourceFlags) -- http://www.wowpedia.org/UnitFlag
		local destReaction = KCL_UnitFlags("reaction", destFlags)
		local sourceRT, sourceRT2 = KCL_UnitFlags("raidtarget", sourceFlags) 
		local destRT, destRT2 = KCL_UnitFlags("raidtarget", destFlags) 
		local sourceLink, destLink, spellIcon, extraSpellIcon
		local schoolName, schoolColor, schoolNameColor
		local extraSchoolName, extraSchoolColor, extraSchoolNameColor
		
		if SuffixParam7 then SuffixParam7 = " "..TEXT_MODE_A_STRING_RESULT_CRITICAL else SuffixParam7 = "" end -- critical; reuse local variable instead of making new local variable
		if SuffixParam9 then SuffixParam9 = " "..TEXT_MODE_A_STRING_RESULT_CRUSHING else SuffixParam9 = "" end -- crushing
		local isTank = (UnitGroupRolesAssigned(sourceName) == "TANK")
		local datestamp1, datestamp2 if profile.Timestamp then datestamp2 = date("[%H:%M:%S] "); datestamp1 = "|cffA9A9A9"..datestamp2.."|r" else datestamp1, datestamp2 = "", "" end
		local sourceName2, destName2 -- call UnitName() whenever possible to remove (cross)realm names
		local a, b, q, r -- function-local scope, dynamic [upvalues / external local variables]

		local chatWindow, chatChannel = char.chatWindow, char.chatChannel -- KethoCombatLog.db.char.chatWindow
		if chatChannel == 2 then q = "SAY"
		elseif chatChannel == 3 then q = "YELL"
		elseif chatChannel == 4 then q = announceType
		else q = "CHANNEL"; r = chatChannel-4
		end

	--	Unit Link -- http://www.wowpedia.org/UI_escape_sequences
		if sourceName then
			if sourceName == playerName then sourceLink = "|cff"..playerColor.."|Hunit:"..sourceGUID..":"..sourceName.."|h["..YOU.."]|h|r" -- You
			elseif UnitInParty(sourceName) or UnitInRaid(sourceName) then sourceName2, sourceLink = KCL_UnitLinkClass("source", "group", select(2,UnitClass(sourceName)), sourceGUID, sourceName) -- Party/Raid Class Color
			elseif sourceType == 0 and sourceName == UnitName("target") then sourceName2, sourceLink = KCL_UnitLinkClass("source", "target", select(2,UnitClass("target")), sourceGUID, sourceName) -- Target Class Color
			else sourceLink = "|cff"..sourceReaction.."|Hunit:"..sourceGUID..":"..sourceName.."|h["..sourceName.."]|h|r"
			end
			if not sourceName2 then sourceName2 = sourceName end -- fall back to sourceName if unit not in party/raid (for cutting out cross-realm names)
		end
		if destName then
			if destName == playerName then
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = YOU end
				destLink = "|cff"..playerColor.."|Hunit:"..destGUID..":"..destName.."|h["..a.."]|h|r"
			elseif UnitInParty(destName) or UnitInRaid(destName) then destName2, destLink = KCL_UnitLinkClass("dest", "group", select(2,UnitClass(destName)), destGUID, sourceName, destName)
			elseif destType == 0 and destName == UnitName("target") then destName2, destLink = KCL_UnitLinkClass("dest", "target", select(2,UnitClass("target")), destGUID, sourceName, destName)
			else
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = destName end
				destLink = "|cff"..destReaction.."|Hunit:"..destGUID..":"..destName.."|h["..a.."]|h|r"
			end
			if destName == sourceName then destName2 = QUICKBUTTON_NAME_SELF end
			if not destName2 then destName2 = destName end -- fall back to destName if cant get valid UnitId
		end

		if event ~= "SWING_DAMAGE" and event ~= "SWING_MISSED" and event ~= "UNIT_DIED" and event ~= "PARTY_KILL" and event ~= "UNIT_DESTROYED" and event ~= "UNIT_DISSIPATES" then
		--	Spell School (Colored)
			if spellSchool then schoolName, schoolColor, schoolNameColor = KCL_spellSchool(spellSchool) end
		--	Spell Link + Colored
			spellLink = "|cff71d5ff|Hspell:"..spellID.."|h["..spellName.."]|h|r"
			spellLinkColor = "|cff"..schoolColor.."|Hspell:"..spellID.."|h["..spellName.."]|h|r"
		--	Spell Icon
			if select(3, GetSpellInfo(spellID)) and profile.iconSize > 1 then
				spellIcon = "|T"..select(3,GetSpellInfo(spellID))..":"..profile.iconSize..":"..profile.iconSize..":1:0:"..iconCropped.."|t"
			else spellIcon = ""
			end
			if event == "SPELL_INTERRUPT" or event == "SPELL_DISPEL" or event == "SPELL_DISPEL_FAILED" or event == "SPELL_STOLEN" or event == "SPELL_AURA_BROKEN_SPELL" then
				if SuffixParam3 then extraSchoolName, extraSchoolColor, extraSchoolNameColor = KCL_spellSchool(SuffixParam3) end
				extraSpellLink = "|cff71d5ff|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r"
				extraSpellLinkColor = "|cff"..extraSchoolColor.."|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r"
				if select(3, GetSpellInfo(SuffixParam1)) and profile.iconSize > 1 then
					extraSpellIcon = "|T"..select(3,GetSpellInfo(SuffixParam1))..":"..profile.iconSize..":"..profile.iconSize..":1:0:"..iconCropped.."|t"
				else extraSpellIcon = ""
				end
			end
		end
	---- Combat Events ----
	--	Deaths
		if profile.Death and destType == 0 and (Time > cd.Death or destName ~= lastDeath) then cd.Death = Time + 1 -- make sure dont show more than 1 killing blow on same person
			if (event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0 then lastDeath = destName
				if not sourceLink then sourceLink = "" end -- no sourceName
				if sourceName2 then a = "["..sourceName2.."]" else a = "" end
				if destName == playerName then b = " "..format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, SuffixParam2) else b = "" end -- show overkill if the player died
				if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexDeath..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink..spellLinkColor..spellIcon.." "..SuffixParam1.." "..schoolNameColor..b..SuffixParam7..SuffixParam9) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2..a..spellLink.." "..SuffixParam1.." "..schoolName..SuffixParam7..SuffixParam9, q, nil, r) end
		--	"SWING_DAMAGE" event uses a different arguments system (spellID, spellName, spellSchool are "skipped")
			elseif event == "SWING_DAMAGE" and spellName > 0 then
				lastDeath = destName
				if SuffixParam4 then SuffixParam4 = " "..TEXT_MODE_A_STRING_RESULT_CRITICAL else SuffixParam4 = "" end -- critical; reuse local variable instead of making new local variable
				if SuffixParam6 then SuffixParam6 = " "..TEXT_MODE_A_STRING_RESULT_CRUSHING else SuffixParam6 = "" end -- crushing
				if destName == playerName then b = " "..format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, spellName) else b = "" end
				if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexDeath..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink.." "..spellID.." |cff"..hexPhysical..MELEE.."|r"..b..SuffixParam4..SuffixParam6) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."] "..spellID.." "..MELEE..SuffixParam4..SuffixParam6, q, nil, r) end
		--	Death Prevents
			elseif event == "SPELL_HEAL" and (spellID == 48153 or spellID == 66235) then -- Priest [Guardian Spirit]48153(SPELL_HEAL) Paladin [Ardent Defender] 66235(SPELL_HEAL)
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor.." |cff"..hexResurrection.."prevented death|r "..destRT..destLink.." "..SuffixParam1.." "..schoolNameColor) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." prevented death "..destRT2.."["..destName2.."]"..spellLink.." "..SuffixParam1.." "..schoolName, q, nil, r) end
		--	Instagibs
			elseif event == "SPELL_INSTAKILL" then
				if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexDeath.."insta"..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink..spellLinkColor..spellIcon) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] insta"..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."]"..spellLink, q, nil, r) end
			end
		end
	--	Taunts
		if profile.Taunt and ((instanceType ~= "party" and instanceType ~= "raid") or profile.tankTaunt or (profile.tankTaunt == false and isTank == false)) then -- 1) not in instance/raid group; 2) in instance/raid group and option is on; 3) in instance party and source is not tank
			if (destType == 3 or destType == 4) and KCL_checkTable(spellID, Taunt) then
				if event == "SPELL_AURA_APPLIED" then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexTaunt.."taunted|r "..destRT..destLink) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." taunted "..destRT2.."["..destName2.."]", q, nil, r) end
			--	Taunt Missed
				elseif event == "SPELL_MISSED" and (SuffixParam1 == "MISS" or SuffixParam1 == "RESIST" or SuffixParam1 == "IMMUNE") then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." on "..destRT..destLink.." |cffFF7800failed|r ("..SuffixParam1..")") end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.."  on "..destRT2.."["..destName2.."] failed", q, nil, r) end
				end
			elseif event == "SPELL_CAST_SUCCESS" then
			--	AoE Taunt: Warrior 1161[Challenging Shout], Druid 5209[Challenging Roar]
				if spellID == 1161 or spellID == 5209 then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." AoE Taunt", profile.color.Taunt.r, profile.color.Taunt.g, profile.color.Taunt.b) end -- some variation in the coloring method :)
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." AoE Taunt", q, nil, r) end
			--	Pet Growl
				elseif profile.petGrowl and (destType == 3 or destType == 4) and KCL_checkTable(spellID, Growl) then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." growled "..destRT..destLink) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." growled "..destRT2.."["..destName2.."]", q, nil, r) end
				end
			end
		end
	--	Interrupts
		if event == "SPELL_INTERRUPT" and profile.Interrupt then
			if not sourceLink then sourceLink = "" end
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexInterrupt.."interrupted|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." interrupted "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Dispels
		elseif event == "SPELL_DISPEL" and profile.Dispel then
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexDispel.."dispelled|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." dispelled "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Spellsteals
		elseif event == "SPELL_STOLEN" and profile.Dispel then
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexDispel.."stole|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." stole "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Reflects
		elseif event == "SPELL_MISSED" and profile.Reflect and SuffixParam1 == "REFLECT" then
			if not sourceLink then sourceLink = "" end
			if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexReflect.."reflected|r "..sourceRT..sourceLink..spellLinkColor..spellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] reflected "..sourceRT2.."["..sourceName2.."]"..spellLink, q, nil, r) end
	--	Resurrections
		elseif event == "SPELL_RESURRECT" and profile.Resurrection then
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexResurrection.."resurrected|r "..destRT..destLink) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." resurrected "..destRT2.."["..destName2.."]", q, nil, r) end
	--	Crowd Control
		elseif event == "SPELL_AURA_APPLIED" and profile.CrowdControl then
			if KCL_checkTable(spellID, CrowdControl) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexCrowdControl.."CC'ed|r "..destRT..destLink) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." CC'ed "..destRT2.."["..destName2.."]", q, nil, r) end
			end
	--	CC Breaker
		elseif profile.CC_Break and ((instanceType ~= "party" and instanceType ~= "raid") or profile.tankBreaksCC or (profile.tankBreaksCC == false and isTank == false)) then
			if event == "SPELL_AURA_BROKEN_SPELL" then -- broken by a spell
				if not sourceLink then sourceLink = "" end
				if sourceName2 then a = "["..sourceName2.."]" else a = "" end
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..extraSpellLinkColor..extraSpellIcon.." |cff"..hexCC_Break.."broke|r "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2..a..extraSpellLink.." broke "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			elseif event == "SPELL_AURA_BROKEN" then -- not broken by a spell; 4.0.1 bug? this event does not fire for CLEU
				if sourceName then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." |cff"..hexCC_Break.."broke|r "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]".." broke "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
				else
					if chatWindow>1 then CF:AddMessage(datestamp1..spellLinkColor..spellIcon.." on "..destRT..destLink.." |cff"..hexCC_Break.."broken|r") end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..spellLink.." on "..destRT2.."["..destName2.."] broken", q, nil, r) end
				end
			end
		end
	--	Feast, Repair Bot, Fun
		if profile.Feast then
			if event == "SPELL_CREATE" and
			(spellID == 87644 or -- [Seafood Magnifique Feast]
			spellID == 87643 or -- [Broiled Dragon Feast]
			spellID == 87915 or -- [Goblin Barbecue Feast]
			spellID == 57426 or -- [Fish Feast]
			spellID == 57301 or -- [Great Feast]
			spellID == 56245 or -- [Chocolate Celebration Cake]
			spellID == 57301) then -- [Lovely Cake]
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then SCM("["..sourceName2.."] prepared a "..spellLink, "BATTLEGROUND")
				else
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." prepared a "..spellLinkColor..spellIcon) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] prepared a "..spellLink, q, nil, r) end
				end
			end
		end
		if profile.RepairBot then
			if (event == "SPELL_CREATE" and spellID == 51710) or
			(event == "SPELL_SUMMON" and spellID == 67826 or spellID == 54711) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." used "..spellLinkColor..spellIcon) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] used "..spellLink, q, nil, r) end
			end
		end
		if profile.Fun and playerName ~= sourceName then -- dont show yourself xD
			if (event == "SPELL_CAST_START" and spellID == 58493) or -- S 58493[Mohawked!]
			(event == "SPELL_AURA_APPLIED" and
			(spellID == 61834 or -- [Manabonked!] (NPC)
			spellID == 61819 or -- [Manabonked!] (Item)
			spellID == 60122 or -- [Baby Spice]
			((spellID == 55346 or -- [Dark Jade Beam]
			spellID == 56190 or -- [Shadow Crystal Focusing Lens]
			spellID == 56191) and destName ~= sourceName) or -- [Shadow Jade Focusing Lens]
			strfind(spellName, "Costume") or
			spellID == 27571 or -- [Cascade of Roses]  Love is in the Air
			spellID == 61815 or -- [Sprung!]  Noblegarden
			spellID == 44212 or -- [Jack-o'-Lanterned!]  Hallow's End
			spellID == 61781 or -- [Turkey Feathers]  Pilgrim's Bounty
			spellID == 44755)) or -- [Snowflakes]  Feast of Winter Veil
			(event == "SPELL_CREATE" and
			(spellID == 61031 or -- [Toy Train Set]
			spellID == 49844 or -- [Using Direbrew's Remote]
			spellID == 43808 or -- [Brewfest Pony Keg]
			spellID == 62857)) then -- [Sandbox Tiger]
				if spellID == 61031 or spellID == 49844 then SCM("["..sourceName2.."] used "..spellLink, announceType) -- Toy Train, Direbrew's Remote
				else
					if destName then a = " on "..destRT..destLink else a = "" end CF:AddMessage(datestamp1..sourceRT..sourceLink.." used "..spellLinkColor..spellIcon..a)
				end
			end
		end
	--	Class Ability
		if event == "SPELL_AURA_APPLIED" then
			if (spellID == 29166 and profile.abilityInnervate) or
			(spellID == 34477 and profile.abilityMisdirection) or
			(spellID == 54646 and profile.abilityFocusMagic) or
			(spellID == 57934 and profile.abilityTricksTrade) or
			(spellID == 20707 and profile.abilitySoulstone) or
			(spellID == 6346 and profile.abilityFearWard) or
			(spellID == 50720 and profile.abilityVigilance) or
			(spellID == 2096 and profile.abilityBloodlust and destName ~= sourceName) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if chatChannel>1 and spellID ~= 2096 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			end
		elseif event == "SPELL_CAST_SUCCESS" then
			if profile.abilityBloodlust and ((spellID == 32182 or spellID == 2825 or spellID == 80353) and Time > cd.Bloodlust) or
			(spellID == 43987 and profile.abilityRitualRefreshment and Time > cd.RitualRefreshment) then
				if spellID == 32182 or spellID == 2825 or spellID == 80353 then cd.Bloodlust = Time + 130 -- set cooldowns
				elseif spellID == 43987 then cd.RitualRefreshment = Time + 130 end
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then SCM("["..sourceName2.."] cast "..spellLink, "BATTLEGROUND") -- Heroism/Bloodlust/Timewarp "wasted" before bg starts; Ritual of Refreshment
				else
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink, q, nil, r) end
				end
			end
		end
	end
end

	-------------------------
	-----  END OF ADDON -----
	-------------------------
--[[
# Version History
	v0.93 [2010.12.05]	Hotfixed: TOC (Table of Contents)
	v0.92 [2010.12.04]	Fixed: "too many upvalues" error
						Fixed: Repair Bot, Fun now work properly, Crowd Control now works on all Locales
						Added: Toggle Options for Blizzard CombatLog, Chat Logging, and Combat Logging
						Code Refactoring/Optimizing
	v0.91 [2010.12.01]	<BROKEN>
						Added: Say, Yell channel options
						Fixed: Critical/Crushing Melee swing death message
						Localized: Overkill string
	v0.90 [2010.11.29]	Completely rewrote and optimized code; Renamed from [Ketho Combat] to [Ketho CombatLog]
						Updated to Ace3 r981 [2010.10.27], from r907 [2009.12.16]
						Added: Advanced options for Coloring & Icons, Raid Target Icons (if assigned to unit)
						Added: Chat Commands; Type "/ket help" for more info
						Removed: Boss/Battleground Mods, Instance Timer
						Improved localization (used strings from GlobalStrings.lua whenever possible)
						Now properly implement "Unit Links" for Shift-left-clicking and right-clicking them
	v0.71 [2010.04.16]	Added: Profiles
	v0.70 [2010.01.21]	Added: GUI options, properly embeded the Ace3 libraries now
	r1	  [2009.11.24]	Initial Release (very noob coded ><)
						This AddOn was inspired by Taunt Tattle from casualcorp @Curse
# Links
	AddOn: Curse			http://wow.curse.com/downloads/wow-addons/details/ketho-combat.aspx
	Ladik's MPQ Editor		http://zezula.net/en/mpq/download.html
	BLP2PNG					http://www.wowinterface.com/downloads/info6127-BLP2PNG.html
--]]